/***************************************************************************
 *            main.cc
 *
 *  Thu Jan 13 15:47:35 2005
 *  Copyright  2005  Michael Hofmann
 *  mh21@gmx.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <glibmm/spawn.h>

#include <sstream>
#include <iostream>
#include <vector>
#include <string>

#include <ext/stdio_filebuf.h>

// escape " and \, change certain letters, should be much nicer
std::string escape (const std::string s)
{
    std::string s2;
    for (std::string::const_iterator i = s.begin(); i != s.end(); ++i) {
	switch (*i) {
	  case char (0xc3): 
	    // Unicode :e for dutch synthesis
	    if (*(i + 1) == char (0xab)) {
	        s2 += 'e';
	        ++i;
	    }
	    break;
	  case '\\': 
	  case '"': 
	    s2 += "\\";
	  default:
	    s2 += *i;
	}
    }
    return s2;
}

int main(int argc, char **argv) 
{
    #ifndef WIN32
    if (argc < 2) return 1;

    std::vector<std::string> paramv;
	paramv.push_back ("festival");

	int pipe = 1;
	
    try {
        Glib::spawn_async_with_pipes (".", paramv, std::vector<std::string>(),
          Glib::SpawnFlags (G_SPAWN_SEARCH_PATH), sigc::slot<void>(), 0, &pipe);
    } catch (Glib::Error e) {
        g_critical (e.what().c_str());
    };
    #if (__GNUC__ > 3) || (__GNUC__ == 3 && __GNUC_MINOR_ >= 4)
	__gnu_cxx::stdio_filebuf<char> fb (pipe, std::ios_base::out, static_cast<size_t> (BUFSIZ));
    #else
        __gnu_cxx::stdio_filebuf<char> fb (pipe, std::ios_base::out, true, static_cast<size_t> (BUFSIZ));
    #endif
	std::basic_ostream<char> str (&fb);

	str << "(" << argv[1] << ")" << std::endl;
	
    std::string s;
    while (getline (std::cin, s)) {
	str << "(SayText \"" << escape (s) << "\")" << std::endl;
    }

    #endif
    return 0;
}
