#!/bin/sh

# Which voice do you want? m=male f=female
VOICE=$1

# Where do we find the mbrola '...' voice?
LANGBASE=/usr/local/share/mbrola/$2/$2

# Home directory of txt2pho
TXT2PHO_DIR="/usr/local/lib/txt2pho"


# We first have to change into the txt2pho homedir
# since txt2pho needs to run there.
cd $TXT2PHO_DIR

# We need GNU tools that are aware UTF-8 characters
export LC_ALL=en_GB.UTF_8

# Choose audio player
while read text; do
    TMPDIR=`mktemp -d /tmp/mbrola.XXXXXX` || exit 1
    echo $text | \
      sed 's/"//g;s/[üÜäÄöÖ]/"&/g;y/üÜäÄöÖß/uUaAoOs/' | \
      txt2pho $VOICE | \
      tee $TMPDIR/phones.txt | \
      mbrola -e $LANGBASE "-" $TMPDIR/out.wav
    play $TMPDIR/out.wav
    rm -r $TMPDIR
done
