/***************************************************************************
 *            CellRendererCompletion.cc
 *
 *  Wed Dec  8 19:41:14 2004
 *  Copyright  2004  Michael Hofmann
 *  mh21@gmx.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
/** \file
 * Editable CellRenderer with history.
 */

#include "debug.h"

#include "CellRendererCompletion.h"

#include <gtkmm/entry.h>

/** Initialize a new instance.
 * \param completion The Gtk::EntryCompletion that should be passed to the Gtk::Entry for
 * history
 */

CellRendererCompletion::CellRendererCompletion (Glib::RefPtr<Gtk::EntryCompletion> completion) :
  completion (completion)
{
    signal_editing_started().connect (sigc::mem_fun (*this, &CellRendererCompletion::hook_completion));
}

void CellRendererCompletion::hook_completion (Gtk::CellEditable* widget, const Glib::ustring& path)
{
    debug_log ("Hooking completion for cell renderer");
    dynamic_cast<Gtk::Entry*> (widget)->set_completion (completion);
}

/*
Gtk::CellEditable* CellRendererCompletion::start_editing_vfunc (GdkEvent* event,
  Gtk::Widget& widget, const Glib::ustring& path, const Gdk::Rectangle& background_area,
  const Gdk::Rectangle& cell_area, Gtk::CellRendererState flags)
{
    Gtk::CellEditable* edit = CellRendererText::start_editing_vfunc (event, widget, 
      path, background_area, cell_area, flags);
    dynamic_cast<Gtk::Entry*> (edit)->set_completion (completion);
    return edit;
}
*/
