/***************************************************************************
 *            CellRendererCompletion.h
 *
 *  Wed Dec  8 19:38:29 2004
 *  Copyright  2004  Michael Hofmann
 *  mh21@gmx.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _CELLRENDERERCOMPLETION_H
#define _CELLRENDERERCOMPLETION_H

/** \file
 * Editable CellRenderer with history.
 */

#include <gtkmm/cellrenderertext.h>

#ifndef DOXYGEN_SHOULD_SKIP_THIS

namespace Gtk {
    class EntryCompletion;
}

#endif

/** Implements a Gtk::CellRendererText that has history.
 */

class CellRendererCompletion : public Gtk::CellRendererText
{
  public:
      CellRendererCompletion (Glib::RefPtr<Gtk::EntryCompletion> completion);
  
  protected:
    void hook_completion (Gtk::CellEditable* widget, const Glib::ustring& path);
//  This worked for GTKmm 2.4
//  virtual Gtk::CellEditable* start_editing_vfunc (GdkEvent* event, Gtk::Widget& widget,
//    const Glib::ustring& path, const Gdk::Rectangle& background_area, 
//    const Gdk::Rectangle& cell_area, Gtk::CellRendererState flags);
  
  private:
    Glib::RefPtr<Gtk::EntryCompletion> completion;
};

#endif /* _CELLRENDERERCOMPLETION_H */
