/***************************************************************************
 *            CmdLine.h
 *
 *  Fri Mar  4 18:37:10 2005
 *  Copyright  2005  Michael Hofmann
 *  mh21@gmx.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _CMDLINE_H
#define _CMDLINE_H

#include <boost/scoped_ptr.hpp>

#include <string>
#include <vector>

/** \file
 * Provide access to the cmdline parameters.
 */

/** Provide access to the cmdline parameters not only for main().
 */

class CmdLine
{
  public:
    static void set (const int num, const char* const params[]);
    static const std::vector<std::string>& get();

  private:
    CmdLine() {};
    CmdLine (const int num, const char* const params[]);
    
    const std::vector<std::string> vals;
    static boost::scoped_ptr<CmdLine> singleton;
};

#endif /* _CMDLINE_H */
