/***************************************************************************
 *            GlobalXML.cc
 *
 *  Fri Nov 19 19:59:35 2004
 *  Copyright  2004  Michael Hofmann
 *  mh21@gmx.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
/** \file
 * A libglade singleton.
 */
 
#include "GlobalXML.h"
#include "ProgramPaths.h"

/** Initializes the singleton and loads the glade file from 
 * <tt>PACKAGE_DATA_DIR/GETTEXT_PACKAGE/GETTEXT_PACKAGE.glade</tt> (Unix).
 */

GlobalXML::GlobalXML() :
    xml (Gnome::Glade::Xml::create (ProgramPaths::glade()))
{
}


/** Return a pointer to the libglade instance.
 * \return Instance pointer to libglade XML class
 */

Glib::RefPtr<Gnome::Glade::Xml> GlobalXML::get_glade() 
{
    return xml;
}
