/***************************************************************************
 *            SettingsManager.cc
 *
 *  Mon Nov 29 18:56:16 2004
 *  Copyright  2004  Michael Hofmann
 *  mh21@gmx.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "SettingsManager.h"

SettingsManager::SettingsManager()
{
}

SettingsManager::~SettingsManager()
{
}

int SettingsManager::get_int (const std::string& group, const std::string& key) const
{
    int newval;
    return get_checked_int (group, key, newval) ? newval : 0;
}

unsigned SettingsManager::get_unsigned (const std::string& group, const std::string& key) const
{
    unsigned newval;
    return get_checked_unsigned (group, key, newval) ? newval : 0;
}

float SettingsManager::get_float (const std::string& group, const std::string& key) const
{
    float newval;
    return get_checked_float (group, key, newval) ? newval : 0;
}

std::string SettingsManager::get_string (const std::string& group, const std::string& key) const
{
    std::string newval;
    return get_checked_string (group, key, newval) ? newval : "";
}

bool SettingsManager::get_bool (const std::string& group, const std::string& key) const
{
    bool newval;
    return get_checked_bool (group, key, newval) ? newval : false;
}

// Dummy functions

// Implemented as fallback to the template version
void SettingsManager::set_int (const std::string& group, const std::string& key, const int value)
{
    return set (group, key, value);
}

// Implemented as fallback to the template version
void SettingsManager::set_unsigned (const std::string& group, const std::string& key, const unsigned value)
{
    return set (group, key, value);
}

// Implemented as fallback to the template version
void SettingsManager::set_float (const std::string& group, const std::string& key, const float value)
{
    return set (group, key, value);
}

// Implemented as fallback to the template version
void SettingsManager::set_bool (const std::string& group, const std::string& key, const bool value)
{
    return set (group, key, value);
}

// Implemented as fallback to the template version
bool SettingsManager::get_checked_int (const std::string& group, const std::string& key, int& value) const
{
    return get_checked (group, key, value);
}

// Implemented as fallback to the template version
bool SettingsManager::get_checked_unsigned (const std::string& group, const std::string& key, unsigned& value) const
{
    return get_checked (group, key, value);
}

// Implemented as fallback to the template version
bool SettingsManager::get_checked_float (const std::string& group, const std::string& key, float& value) const
{
    return get_checked (group, key, value);
}

// Implemented as fallback to the template version
bool SettingsManager::get_checked_bool (const std::string& group, const std::string& key, bool& value) const
{
    return get_checked (group, key, value);
}
