/***************************************************************************
 *            StressBase.h
 *
 *  Wed Jan 12 11:14:22 2005
 *  Copyright  2005  Michael Hofmann
 *  mh21@gmx.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _STRESSBASE_H
#define _STRESSBASE_H

#include "md5.h"

#include <boost/shared_ptr.hpp>

#include <string>

class StressBase;
    
typedef boost::shared_ptr<StressBase> StressBasePtr;

class StressBase 
{
  public:
    virtual ~ StressBase() {};
		
    virtual void load (const std::string& file) = 0;

    virtual int get_accent (const std::string& name) const = 0;

  protected:
    static long long unsigned get_md5 (const std::string& name);
};


#endif
