/***************************************************************************
 *            StressBaseInterface.cc
 *
 *  Wed Jan 12 20:07:16 2005
 *  Copyright  2005  Michael Hofmann
 *  mh21@gmx.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include "StressBaseInterface.h"

#include "ApplicationSettings.h"
#include "BinaryStressBase.h"

int StressBaseInterface::get_stress_pos (const std::string& word, const std::string& language)
{
    update_language (language);
    if (data[language]) {
	int stresspos = data[language]->get_accent (word);
	if (stresspos > 0)
	  return stresspos;
	return -1;
    } else {
        return -1;
    }
}
  
void StressBaseInterface::update_language (const std::string& language)
{
    std::string base = ApplicationSettings::get().get_stressbase_base (language);
    if (base != old_paths[language]) {
	data[language].reset (new BinaryStressBase (base));
	old_paths[language] = base;
    }
}
