/***************************************************************************
 *            StressBaseInterface.h
 *
 *  Wed Jan 12 20:07:00 2005
 *  Copyright  2005  Michael Hofmann
 *  mh21@gmx.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _STRESSBASEINTERFACE_H
#define _STRESSBASEINTERFACE_H

#include "StressBase.h"
#include "RegisteredSingleton.h"

#include <map>
#include <string>
    
class StressBaseInterface : public RegisteredSingleton<StressBaseInterface, 50>
{
  public:
    int get_stress_pos (const std::string& word, const std::string& language);
  
  protected:
    void update_language (const std::string& language);
  
    std::map<std::string, std::string> old_paths;
    std::map<std::string, StressBasePtr> data;
};

#endif /* _STRESSBASEINTERFACE_H */
