/***************************************************************************
 *            SynthesisInterface.h
 *
 *  Thu Jan 13 13:03:10 2005
 *  Copyright  2005  Michael Hofmann
 *  mh21@gmx.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _SYNTHESISINTERFACE_H
#define _SYNTHESISINTERFACE_H

#include "SynthesisProgram.h"
#include "RegisteredSingleton.h"

#include <sigc++/connection.h>

#include <map>
#include <string>
    
class SynthesisInterface : public RegisteredSingleton<SynthesisInterface, 50>
{
  public:
    void play (const unsigned delay, const std::string& text, const std::string& language);
    bool available (const std::string& language) const;
  
  protected:
    void update_language (const std::string& language);
    bool timeout (const std::string& language);
  
    typedef std::map<std::string, std::string> StringMap;
  
    StringMap old_paths;
    StringMap old_params;
    std::map<std::string, SynthesisProgramPtr> data;
    std::map<std::string, sigc::connection> timeouts;
};

#endif /* _SYNTHESISINTERFACE_H */
