/***************************************************************************
 *            SynthesisProgram.h
 *
 *  Thu Jan 13 13:12:18 2005
 *  Copyright  2005  Michael Hofmann
 *  mh21@gmx.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _SYNTHESISPROGRAM_H
#define _SYNTHESISPROGRAM_H
    
#include <boost/utility.hpp>
#include <boost/shared_ptr.hpp>

#include <string>

class SynthesisProgram;

typedef boost::shared_ptr<SynthesisProgram> SynthesisProgramPtr;

class SynthesisProgram : public boost::noncopyable
{
  public:
    SynthesisProgram();
    SynthesisProgram (const std::string& file, const std::string& params);
    ~ SynthesisProgram();

    void run (const std::string& file, const std::string& params);
    void play (const unsigned delay, const std::string& text) const;

  protected:
    bool play_now (const std::string& text) const;
    void terminate();
  
    int prog_pipe;
};

#endif /* _SYNTHESISPROGRAM_H */
