/***************************************************************************
 *            TempSettingsManager.h
 *
 *  Mon Nov 29 21:04:22 2004
 *  Copyright  2004  Michael Hofmann
 *  mh21@gmx.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _TEMPSETTINGSMANAGER_H
#define _TEMPSETTINGSMANAGER_H

#include "SettingsManager.h"

#include <map>

class TempSettingsManager : public SettingsManager
{
  public:
    virtual void set_string (const std::string& group, const std::string& key, const std::string& value);
    virtual signal_type get_signal (const std::string& group, const std::string& key);
    virtual bool get_checked_string (const std::string& group, const std::string& key, std::string& value) const;
  
    virtual bool delete_entry (const std::string& group, const std::string& key);
    virtual std::string get_name (const std::string& group, const unsigned idx);

    virtual void set_description (const std::string& group, const std::string& key, const std::string& value);
    virtual void set_hint (const std::string& group, const std::string& key, const std::string& value);
  
  protected:
      
    class Setting 
    {
      public:
	std::string value, description, hint;
    };
    
    typedef std::map<std::string, Setting> SettingsMap;
    typedef std::map<std::string, signal_type> SignalMap;
    typedef std::map<std::string, SettingsMap> SettingsGroupMap;
    typedef std::map<std::string, SignalMap> SignalGroupMap;
    SettingsGroupMap settings;
    SignalGroupMap signals;
};

#endif /* _TEMPSETTINGSMANAGER_H */
