/***************************************************************************
 *            TextStressBase.h
 *
 *  Tue Feb  1 12:17:24 2005
 *  Copyright  2005  Michael Hofmann
 *  mh21@gmx.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _TEXTSTRESSBASE_H
#define _TEXTSTRESSBASE_H

#include "StressBase.h"

#include <boost/utility.hpp>

#include <map>

class TextStressBase : public StressBase, public boost::noncopyable
{
  public:
    TextStressBase();
    TextStressBase (const std::string& file);

    void load (const std::string& file);
    void save_binary (const std::string& file);
  
    virtual int get_accent (const std::string& name) const;

  protected:
    typedef std::map<long long unsigned, unsigned char> AccentMap;
    AccentMap accents;
};

#endif /* _TEXTSTRESSBASE_H */
