/***************************************************************************
 *            VocabScoreDiagram.cc
 *
 *  Sun Jul 17 19:47:49 2005
 *  Copyright  2005  Michael Hofmann
 *  mh21@gmx.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include "VocabScoreDiagram.h"
#include "VocabTest.h"
#include "VocabCache.h"

VocabScoreDiagram::VocabScoreDiagram (BaseObjectType* cobject, const Glib::RefPtr<Gnome::Glade::Xml>& refGlade) :
  Glib::ObjectBase (typeid (VocabScoreDiagram)),
  ScoreDiagram (cobject, refGlade)
{
}
  
void VocabScoreDiagram::set_vocabs (const VocabTest& vocab_test)
{
    std::vector<float> scores;
    const VocabCache& vocab_cache = VocabCache::get();
    const int chapters = vocab_test.get_chapter_num();
    for (int chapter = 0; chapter < chapters; ++chapter) {
        const int sections = vocab_test.get_section_num (chapter);
        for (int section = 0; section < sections; ++section) {
	    const int vocabs = vocab_test.get_vocab_num (chapter, section);
	    for (int vocab = 0; vocab < vocabs; ++vocab) {
		const unsigned id = vocab_test.get_id (chapter, section, vocab);
		scores.push_back (vocab_cache.get_score (id));
	    }
	}
    }
    std::sort (scores.begin(), scores.end());
    set_points (scores.begin(), scores.end());
}
