/***************************************************************************
 *            XMLSettingsManager.h
 *
 *  Mon Nov 29 21:04:22 2004
 *  Copyright  2004  Michael Hofmann
 *  mh21@gmx.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _XMLSETTINGSMANAGER_H
#define _XMLSETTINGSMANAGER_H

#include "TempSettingsManager.h"

#include <map>
#include <string>

class XMLSettingsManager : public TempSettingsManager
{
  public:
    XMLSettingsManager (const std::string& configname);
    virtual ~ XMLSettingsManager();

  protected:
    static const std::string print_group (const SettingsGroupMap::value_type& t);
    static const std::string print_key (const SettingsMap::value_type& t);

    const std::string filename;
  
  friend std::ostream& operator << (std::ostream& strm, const XMLSettingsManager& d);
};

#endif /* _XMLSETTINGSMANAGER_H */
