/***************************************************************************
 *            exception.h
 *
 *  Tue Oct 12 20:52:25 2004
 *  Copyright  2004  Michael Hofmann
 *  mh21@gmx.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _EXCEPTION_H
#define _EXCEPTION_H

/** \file
 * Basic exception class.
 */

#include <boost/shared_ptr.hpp>

#include <exception>
#include <string>

/** Basic exception class.
 * It provides an error reason and an optional message.
 */

class ApplicationError : public std::exception
{
  public:
    ApplicationError (const std::string & reason);
    ApplicationError (const std::string & message, const std::string & reason);
    ~ ApplicationError() throw();

    virtual const char * what() const throw();
  private:
    class m_imp;
    boost::shared_ptr<m_imp> m_imp_ptr;
};

#endif
