/***************************************************************************
 *            support.h
 *
 *  Wed Oct 13 11:41:50 2004
 *  Copyright  2004  Michael Hofmann
 *  mh21@gmx.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _SUPPORT_H
#define _SUPPORT_H

/** \file
 * Some utility functions that didn't fit somewhere else.
 */
 
#ifndef DOXYGEN_SHOULD_IGNORE_THIS

namespace Gtk {
    class TreeView;
}

#endif

bool cursor_visible (Gtk::TreeView* tv);

unsigned generic_random (const unsigned n = 0);

/** Pretends the use of a variable.
 * \param var Variable for which the warning should be ignored
 */

template <class T> inline void ignore_unused_variable_warning (const T& var) { };

/** Get a widget from glade.
 * \param xml glade instance
 * \param what widget name and glade identifier
 */
#define GET_GLADE(xml,what) \
    G_STMT_START { \
	(xml)->get_widget (G_STRINGIFY (what), (what)); \
	debug_assert ((what) != NULL); \
    } G_STMT_END
#endif /* _SUPPORT_H */
